<?php

#########################################################################
#                            mysql.inc.php                              #
#                                                                       #
#               Functions for mysql support                             #
#               Dernire modification : 20/06/2006                      #
#                                                                       #
#                                                                       #
#########################################################################
/*
 * From http://mrbs.sourceforge.net/
 *
 * This file is part of Community Translation System (CTS).
 *
 * CTS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CTS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GRR; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

require "../config/config.inc.php";


// Connection to the database
$db_c = mysql_pconnect($dbhost, $dbuser, $dbpass);

if (!$db_c || !mysql_select_db ($dbname))
{
    echo "<p> failed_connect_db \n";
    exit;
}


// Free a results handle. You need not call this if you call sql_row or
// sql_row_keyed until the row returns 0, since sql_row frees the results
// handle when you finish reading the rows.
function sql_free ($r)
{
    mysql_free_result($r);
}

// Execute a non-SELECT SQL command (insert/update/delete).
// Returns the number of tuples affected if OK (a number >= 0).
// Returns -1 on error; use sql_error to get the error message.
function sql_command ($sql)
{
    if (mysql_query($sql)) return mysql_affected_rows();
    return -1;
}

// Execute an SQL query which should return a single non-negative number value.
// This is a lightweight alternative to sql_query, good for use with count(*)
// and similar queries. It returns -1 on error or if the query did not return
// exactly one value, so error checking is somewhat limited.
// It also returns -1 if the query returns a single NULL value, such as from
// a MIN or MAX aggregate function applied over no rows.
function sql_query1 ($sql)
{
    $r = mysql_query($sql);
    if (! $r) return -1;
    if (mysql_num_rows($r) != 1 || mysql_num_fields($r) != 1
        || ($result = mysql_result($r, 0, 0)) == "") $result = -1;
    mysql_free_result($r);
    return $result;
}

// Execute an SQL query. Returns a database-dependent result handle,
// which should be passed back to sql_row or sql_row_keyed to get the results.
// Returns 0 on error; use sql_error to get the error message.
function sql_query ($sql)
{
    $r = mysql_query($sql);
    return $r;
}

// Return a row from a result. The first row is 0.
// The row is returned as an array with index 0=first column, etc.
// When called with i >= number of rows in the result, cleans up from
// the query and returns 0.
// Typical usage: $i = 0; while ((a = sql_row($r, $i++))) { ... }
function sql_row ($r, $i)
{
    if ($i >= mysql_num_rows($r))
    {
        mysql_free_result($r);
        return 0;
    }
    mysql_data_seek($r, $i);
    return mysql_fetch_row($r);
}

// Return a row from a result as an associative array keyed by field name.
// The first row is 0.
// This is actually upward compatible with sql_row since the underlying
// routing also stores the data under number indexes.
// When called with i >= number of rows in the result, cleans up from
// the query and returns 0.
function sql_row_keyed ($r, $i)
{
    if ($i >= mysql_num_rows($r))
    {
        mysql_free_result($r);
        return 0;
    }
    mysql_data_seek($r, $i);
    return mysql_fetch_array($r);
}

// Return the number of rows returned by a result handle from sql_query.
function sql_count ($r)
{
    return mysql_num_rows($r);
}

// Return the value of an autoincrement field from the last insert.
// Must be called right after an insert on that table!
function sql_insert_id()
{
    return mysql_insert_id();
}

// Return the text of the last error message.
function sql_error()
{
    return mysql_error();
}

// Exexute the trigger function if argument is an sql result error
function sql_error_trigger($result,$trigger)
{
  if (! $result) 
    {
      echo sql_error();
      eval($trigger);
    }

}


// Return a string identifying the database version:
function sql_version()
{
    $r = sql_query("select version()");
    $v = sql_row($r, 0);
    sql_free($r);
    return "MySQL $v[0]";
}



?>